<script lang="ts">
    import type Building from 'models/Building'
    import type DistrictField from 'models/DistrictField'

    import { grid } from 'lib/grid'

    $: constructions = searchBuildingsUnderConstruction($grid)
    let timers = {}

    const searchBuildingsUnderConstruction = grid =>
        Object.values(grid).reduce((previous, current: DistrictField[]) => {
            let tmp: Building[] = Object.values(current).reduce(
                (prev: Building[], curr: DistrictField) => {
                    if (
                        curr.content?.level &&
                        curr.content.isUnderConstruction()
                    ) {
                        curr.content.timerId = curr.content.construction.id
                        curr.content.construction.timeLeft.subscribe(
                            newValue => {
                                timers[curr.content.timerId] = newValue
                            }
                        )
                        return [...prev, curr.content]
                    }
                    return prev
                },
                []
            )
            return [...previous, ...tmp]
        }, [])
</script>

<div class="section">
    <p class="title">Constructions en cours</p>
    {#each constructions as { name, level, timerId }}
        {name} lvl: {level} - {timers[timerId] / 1000} s
    {/each}
</div>

<style lang="postcss">
    .section {
        @apply w-auto flex-col rounded-lg bg-gray-700 py-4 px-4 text-center;
    }
    .title {
        @apply font-bold text-white;
    }
</style>
